disp(' ');
disp('-------------------------------------------------------------------------------');
disp('-------------------------------------------------------------------------------');
disp('Noise cancellation using QRD RLS algorithm');
disp('-------------------------------------------------------------------------------');
disp(' '); 
disp('-------------------------------------------------------------------------------');
disp('Input signal: white noise');
disp('QRD with EF double precision');
disp('Environment model: time-invariant, the 1000th order, 500 zeros in the beginning');
disp('Hand model: time-variant, the 100th order, 3 appearances');
disp('Time scale: 100 000 steps');
disp('-------------------------------------------------------------------------------');
disp(' ');
disp('Computation is in process. Please, wait...');

mur=1;
ur=zeros(mur,1);
u0r=zeros(mur,1);
uxr=zeros(mur,1);
rr=eye(mur);

u0r=0.0;
cfr=0.08;

knr=zeros(mur,1);  
[knr,mur,tmp1,tmp2]=infi(knr,mur,1,0);

xnr=zeros(mur,1);  
[xnr,mur,tmp1,tmp2]=infi(xnr,mur,103,2);

xnpr=zeros(mur,1); 
[xnpr,mur,tmp1,tmp2]=infi(xnpr,mur,0,0);

mys1=1; mys2=1;
mus1=1; mus2=1;

ipss1=23; ipss2=23; 
yips1=2; yips2=2;

ys1=zeros(mys1,1); ys2=zeros(mys2,1);
us1=zeros(mus1,1); us2=zeros(mus2,1);
es1=zeros(mys1,1); es2=zeros(mys2,1);

kns1=zeros(mys1,1);  kns2=zeros(mys2,1);
[kns1,mys1,tmp1,tmp2]=infi(kns1,mys1,1,0); [kns2,mys2,tmp1,tmp2]=infi(kns2,mys2,1,0);

xns1=zeros(mys1,1);  xns2=zeros(mys2,1);
[xns1,mys1,ipss1,yips1]=infi(xns1,mys1,ipss1,yips1); [xns2,mys2,ipss2,yips2]=infi(xns2,mys2,ipss2,yips2);

xnps1=zeros(mys1,1); xnps2=zeros(mys2,1);
[xnps1,mys1,tmp1,tmp2]=infi(xnps1,mys1,0,0); [xnps2,mys2,tmp1,tmp2]=infi(xnps2,mys2,0,0);

lus1=1000; lus2=100;
lys1=0; lys2=0;
les1=1; les2=1;

nus1=0; nus2=0;

kpys1=0; kpys2=0;
iups1=0; iups2=0;
kpus1=0; kpus2=0;
ieps1=0; ieps2=0;
kpes1=0; kpes2=0;
izs1=0; izs2=0;
iers1=0; iers2=0;

iyps1=mys1*lys1; iyps2=mys2*lys2;
kpys1=iyps1-mys1; kpys2=iyps2-mys2;

ipss1=mus1*lus1; ipss2=mus2*lus2;

iups1=mus1*nus1+ipss1; iups2=mus2*nus2+ipss2; 
kpus1=iups1-mus1; kpus2=iups2-mus2;

ieps1=mys1*les1; ieps2=mys2*les2;        
kpes1=ieps1-mys1; kpes2=ieps2-mys2;

izs1=iyps1+ipss1+ieps1+1; izs2=iyps2+ipss2+ieps2+1;

sd03_i1 = [mys1,mus1,iyps1,kpys1,iups1,kpus1,ieps1,kpes1,nus1,izs1];
sd03_i2 = [mys2,mus2,iyps2,kpys2,iups2,kpus2,ieps2,kpes2,nus2,izs2];

if iyps1> 0 yps1=zeros(iyps1,1); else yps1=0; end
if iups1> 0 ups1=zeros(iups1,1); else ups1=0; end
if ieps1> 0 eps1=zeros(ieps1,1); else eps1=0; end

if iyps2> 0 yps2=zeros(iyps2,1); else yps2=0; end
if iups2> 0 ups2=zeros(iups2,1); else ups2=0; end
if ieps2> 0 eps2=zeros(ieps2,1); else eps2=0; end

zs1=zeros(izs1,1); zs2=zeros(izs2,1); 
zs1(izs1,1)=1.0; zs2(izs2,1)=1.0;

b0ps1=0.1; b0ps2=0.1;
bps1=0.9; bps2=0.9;
aps1=0.98; aps2=0.98;
c0ps1=0.02; c0ps2=0.02;
cps1=0.0; cps2=0.0;

ps1=zeros(mys1,izs1); ps2=zeros(mys2,izs2);

[ps1,mys1,mus1,lus1,lys1,les1,izs1,b0ps1,bps1,aps1,c0ps1,cps1,iers1]=...
    mkin(ps1,mys1,mus1,lus1,lys1,les1,izs1,b0ps1,bps1,aps1,c0ps1,cps1,iers1);

[ps2,mys2,mus2,lus2,lys2,les2,izs2,b0ps2,bps2,aps2,c0ps2,cps2,iers2]=...
    mkin(ps2,mys2,mus2,lus2,lys2,les2,izs2,b0ps2,bps2,aps2,c0ps2,cps2,iers2);

nbp1=11; nbp2=14;

mps1=1002; mps2=102;

jts1=[1      1000   2000   3000  3100  3200   3300  3400   3500   4000   100000];

pns1_1=zeros(500,11);
pns1_2=zeros(500,11);
pns1_0=rand(500,1);
pns1_2=pns1_2+pns1_0;
pns1_p=zeros(1,11);
sum1=0.005;
pns1_sum=zeros(1,11);
pns1_sum=pns1_sum+sum1;

pns1=[pns1_1; pns1_2; pns1_sum; pns1_p];

jts2=[1     10000  10001   10050   10051  50000    50001    55000    55001   80000   80001   80050   80051   100000];

zero=zeros(100,2);

pns2_1=rand(100,1);
pns2_1_0=zeros(100,2);
pns2_1=pns2_1_0+pns2_1;

pns2_2=rand(100,1);
pns2_2_0=zeros(100,2);
pns2_2=pns2_2_0+pns2_2;

pns2_3=rand(100,1);
pns2_3_0=zeros(100,2);
pns2_3=pns2_3_0+pns2_3;

pns2=[zero pns2_1 zero pns2_2 zero pns2_3 zero];

sum2=0.05;
pns2_sum=zeros(1, 14);
pns2_sum=pns2_sum+sum2;

pns2_p=zeros(1,14);

pns2=[pns2; pns2_sum; pns2_p];

jtw1=1; jtw2=1;

srw1=zeros(mps1,jtw1); srw2=zeros(mps2,jtw2);

mum=1;
mym=1;
mvm=1;
im=0;

um=zeros(mum,1); 
ym=zeros(mym,1);
vm=zeros(mvm,1); 
wm=0;

lum=1000;
lym=0;
lvm=0;
lem=0; 
l1m=0;
num=0;

ksm=0;
if ksm == 1
    if lum-lym-1 ~= 0
        disp('error: you have to set lum = lym+1 for ksm ==1');
    end
end

kum=0;
kym=0;
kvm=0;
kem=0;
kim=0;

kpm=1;
kpim=1;

izum=mum*(lum+num); 
jum=izum-mum;

izym=mym*(lym+1); 
jym=izym-1;        

izvm=mvm*(lvm);
jvm=izvm-mvm;

izem=mym*lem;    
jem=izem-1;

idm=izum+izym+izvm+izem-(mum*num)+l1m;

md70_i = [mum, mym, mvm, izum, jum, izym, jym, izvm, jvm, ...
    izem, jem, lum, lym, lvm, lem, num, ...
    ksm, kum, kym, kvm, kem, idm, kpm, kpim];

udm=zeros(mum,1); 
ydm=zeros(mym,1); 
vdm=zeros(mvm,1);
edm=zeros(mym,1); 
zym=zeros(izym,1);
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
if izum > 0 zum=zeros(izum,1); else zum=0; end
if izvm > 0 zvm=zeros(izvm,1); else zvm=0; end
if izem > 0 zem=zeros(izem,1); else zem=0; end

dm=zeros(idm,1);
dm(idm,1)=l1m;

dim=zeros(idm,1);
dcm=zeros(idm,1);
admm=0.0*ones(idm,1);
kadm=12*ones(idm,1);

md70_d=[dm, dim, dcm, admm, kadm];

fim=0.999;
%fim=0.9999999999;

pm=zeros(idm,1);

in_diag=1e-3;

lam=in_diag*ones(idm,1);
pzm=zeros(idm,idm);

alm=zeros(idm,1);
epm=zeros(idm,1);
zdm=zeros(idm,1);

rm=0;
em=0;
efm=0;
dfm=3.0;

u=ur;

y1=ys1; y2=ys2; 

N=100000; 
i=1; 
ip=1; 
in=150;

i_loop=1;
comp_t=0;

xx  = zeros(N,1);

yy1_1 = zeros(N,1);
yy1_2 = zeros(N,1);
yy2 = zeros(N,1);
yy3_1 = zeros(N,1);
yy3_2 = zeros(N,1);
yy4 = zeros(N,1);
yy5 = zeros(N,1);
yy6 = zeros(N,1);
yy7 = zeros(N,1);

i_fr=500; 
i_to=1000; 
s_p=40; 
s_a=0.5;

tic;

for i=1:N,
    [u,mur,u0r,uxr,rr,cfr,knr,xnr,xnpr]=...
        r03 (u,mur,u0r,uxr,rr,cfr,knr,xnr,xnpr);
    
    [i,jts1,pns1,jtw1,srw1,mps1,nbp1,ps1]=...
        md81(i,jts1,pns1,jtw1,srw1,mps1,nbp1,ps1);
    
    [i,jts2,pns2,jtw2,srw2,mps2,nbp2,ps2]=...
        md81(i,jts2,pns2,jtw2,srw2,mps2,nbp2,ps2);
    
    [y1,u,es1,xns1,xnps1,yps1,ups1,eps1,ps1,kns1,zs1,sd03_i1]=...
        sd03(y1,u,es1,xns1,xnps1,yps1,ups1,eps1,ps1,kns1,zs1,sd03_i1);
    
    [y2,u,es2,xns2,xnps2,yps2,ups2,eps2,ps2,kns2,zs2,sd03_i2]=...
        sd03(y2,u,es2,xns2,xnps2,yps2,ups2,eps2,ps2,kns2,zs2,sd03_i2);
    
    
    
    y=y1+y2;
    
    [u,y,vm,em,efm,udm,ydm,vdm,edm,zum,zym,zvm,zem,pm,rm,dfm,fim,pzm,lam,zdm,epm,alm,md70_i,md70_d]=...
        md70(u,y,vm,em,efm,udm,ydm,vdm,edm,zum,zym,zvm,zem,pm,rm,dfm,fim,pzm,lam,zdm,epm,alm,md70_i,md70_d);
    
    xx(i)=i;
    yy1_1(i)=ps1(1);
    yy1_2(i)=ps2(1);
    
    yy2(i)=pm(1);
        
    yy3_1(i)=ps1(2);
    yy3_2(i)=ps2(2);
    
    yy4(i)=pm(2);
       
    yy5(i)=em;
        
    yy6(i)=u;
    
    yy7(i)=y2;
    
    yy8(i)=efm;
    
    
end;

comp_t=toc;
disp(['The Loop Computated in ',num2str(comp_t),' seconds']);

hold on;

plot_clr=['g'];

figure(1)
plot(xx,yy1_1,'m',      ...
    xx, yy1_2, 'r', ...
    xx,yy2,plot_clr, ...
    xx,yy5, 'b' , ...
    xx, 0.95+0.025*yy6, 'm', 'LineWidth', 2);
%title('Identification results')
%legend({'Input "u"', 'Parameter', 'Parameter estimation', 'Prediction error'},'Location', 'NorthEast')
set(gca,'fontsize', 18)

figure(2)
plot(xx,yy1_1,'m',      ...
    xx, yy1_2, 'r', ...
    xx,yy2,plot_clr, ...
    xx,yy8, 'b' , ...
    xx, 0.95+0.025*yy6, 'm', 'LineWidth', 2);
%title('Identification results')
%legend({'Input "u"', 'Parameter', 'Parameter estimation', 'Filtration error'},'Location', 'NorthEast')
set(gca,'fontsize', 18)

xxx=[49950:56000];
yyy5=yy5(49950:56000);
yyy7=yy7(49950:56000);

figure(3)
subplot(1,2,1)
plot(xx,yy5, 'b' , ...
     xx,yy7, 'm', 'LineWidth', 2);
%title('Comparison of prediction error "e" and output of the second system "y2"') 
%set(gca,'fontsize', 18)
hold on

xxxx=[49000, 56500, 56500, 49000, 49000];
%yyyy=[-7.5, -7.5, 6, 6, -7.5];
yyyy=[-7, -7, 5.5, 5.5, -7];
plot(xxxx, yyyy, 'g-', 'LineWidth', 2);
%legend({'Prediction error "e"', 'Output "y2"', 'Segment example'}, 'Location', 'NorthEast')

subplot(1,2,2)
plot(xxx, yyy5, 'b', xxx, yyy7, 'm', 'LineWidth', 2);

figure(4)
plot(xx,yy1_1,'m',      ...
    xx, yy1_2, 'r', ...
    xx,yy2,plot_clr, ...
    xx,yy5, 'b' , ...
    xx, yy7, 'm', 'LineWidth', 2);
%title('Identification results')
%legend({'Output "y2"', 'Parameter', 'Parameter estimation', 'Prediction error'},'Location', 'NorthEast')
set(gca,'fontsize', 18)

figure(5)
plot(xx, yy6, 'm', 'LineWidth', 2);
set(gca, 'fontsize', 18)

